#ifndef unix
#define WIN32
#include <windows.h>
#include <winsock.h>
#else
#define closesocket close
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif

#include <stdio.h>
#include <string.h>

#define PROTOPORT 5193
#define QLEN 6

int main (int argc, char *argv[])
{
	struct hostent *ptrh;
	struct protoent *ptrp;
	struct sockaddr_in sad;
	/*server adresa: struktura pre internetovu adresu: http://retran.com/beej/sockaddr_inman.html*/
	struct sockaddr_in cad;  //klientova adrsa
	int sd, sd2;
	int port;
	int alen;
	int n;
	int a[3],vysl[1];
#ifdef WIN32
#define WSADATA wsaData;
#define WSAstartup (0x0101, &wsaData);
#endif

	/*priprav adrsu servera*/
	memset((char *)&sad, 0, sizeof (sad));
	sad.sin_family = AF_INET;
	sad.sin_addr.s_addr = INADDR_ANY;
	
	if (argc > 1)
	{
		port = atoi (argv[1]); //nastav dany port
	}
	else
	{
		port = PROTOPORT;
	}
	
	if (port >0)
		sad.sin_port = htons((u_short)port);
	else 
	{
		fprintf(stderr,"Nespravne cislo portu %s\n",argv[1]);
		exit(1);
	}

	//mapuj TCP nazov protokolu na cislo protokolu
	if (((int)(ptrp = getprotobyname("tcp"))) == 0)//cita riadok z /etc/protocols
	{
	      fprintf(stderr,"Chyba mapovania \"tcp\" na cislo protokolu\n");
		exit(1);
	}

	//vytvor soket komunikacie a vrat descriptor
	sd = socket (PF_INET, SOCK_STREAM, ptrp->p_proto);
	if (sd < 0)
	{
		fprintf(stderr,"Chyba vytvarania soketu\n");
		exit(1);
	}

	//naviaz lokalnu adresu sad na soket sd ("pomenuj soket")
	if (bind(sd, (struct sockaddr *)&sad, sizeof (sad)) < 0)
	{
		fprintf(stderr,"Chyba navezovania\n");
		exit(1);
	}

	//pocuvaj na pripojenom sokete
	if (listen(sd, QLEN) < 0)
	{
		fprintf(stderr, "Chyba nacuvania\n");
		exit(1);
	}
	
	//hlavna slucka= prijmaj a spracuvaj poziadavky
	fprintf(stderr, "Server bezy a je pripraveny na poziadavky\n");
	while(1)
	{
		alen = sizeof(cad);
		fprintf(stderr, "Server: cakam na kontakt...\n");

		if ((sd2 = accept(sd, (struct sockaddr *)&cad, &alen)) < 0)
		{
			fprintf(stderr, "Chyba prijatia poziadavky\n");
			exit(1);
		}

		//klient sa pripojil - cakam na data
		n = recv(sd2, a, sizeof(a), 0);
		//pocet dat ktore sa nacitali
		while (n > 0)
		{
			fprintf(stderr, "Server: Zacinam....\n");
			vysl[0] = a[0] + a[1] + a[2];
			fprintf(stderr, "Server: Vysledok %i\n", vysl[0]);
			fprintf(stderr, "Server: posielam....\n");
			send(sd2, vysl, sizeof(vysl), 0);

			n = recv(sd2, a, sizeof(a), 0);
		}

		fprintf(stderr, "Server: Poslal som...\n");
		
		closesocket (sd2);
	}
}
